#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector<vector<pair<int, int>>> g;
vector<char> used;
vector<vector<long long>> paths;
vector<vector<long long>> paths_ps;
vector<int> path;
vector<int> vnum;

void dfs(int v) {
	if (v == n - 1)
		return;
	path[v] = paths.size() - 1;
	vnum[v] = paths.back().size() - 1;
	used[v] = 1;
	for (auto to : g[v])
		if (!used[to.first]) {
			paths.back().push_back(to.second);
			dfs(to.first);
		}
}

int main(){
	int m, q;
	cin >> n >> m >> q;
	
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int a, b, w;
		cin >> a >> b >> w;
		g[a - 1].push_back({b - 1, w});
		g[b - 1].push_back({a - 1, w});
	}
	
	used.resize(n);
	used[0] = 1;
	path.resize(n);
	vnum.resize(n);
	for (auto to : g[0]) {
		vector<long long> a(1, to.second);
		paths.push_back(a);
		dfs(to.first);
	}
	
	for (auto e : path)
		cout << e << " ";
	cout << endl;
	for (auto e : vnum)
		cout << e << " ";
	cout << endl;
	
	for (auto path : paths) {
		for (auto e : path)
			cout << e << " ";
		cout << endl;
	}
	
	paths_ps.resize(paths.size());
	for (int i = 0; i < paths.size(); ++i) {
		paths_ps[i].resize(paths[i].size());
		paths_ps[i][0] = paths[i][0];
		for (int j = 1; j < paths_ps[i].size(); ++j)
			paths_ps[i][j] = paths_ps[i][j - 1] + paths[i][j];
	}
	
	for (auto path : paths_ps) {
		for (auto e : path)
			cout << e << " ";
		cout << endl;
	}
	
	long long mn = 1e18;
	for (int i = 0; i < paths.size(); ++i)
		mn = min(mn, paths_ps[i].back());
	
	cout << "mn = " << mn << endl;
	
	for (int i = 0; i < q; ++i) {
		int a, b;
		cin >> a >> b;
		--a;
		--b;
		if (a > b)
			swap(a, b);
		if (a == b)
			cout << 0 << " ";
		else if (a == 0 && b == n - 1)
			cout << mn << " ";
		else if (a == 0) {
			int pb = path[b];
			int nb = vnum[b];
			cout << min(paths_ps[pb][nb], paths_ps[pb].back() - paths_ps[pb][nb] + mn) << " ";
		}
		else if (b == n - 1) {
			int pa = path[a];
			int na = vnum[a];
			cout << min(paths_ps[pa].back() - paths_ps[pa][na], paths_ps[pa][na] + mn) << " ";
		}
		else if (path[a] == path[b]) {
			if (vnum[a] > vnum[b])
				swap(a, b);
			int pa = path[a];
			int pb = path[b];
			int na = vnum[a];
			int nb = vnum[b];
			cout << min(paths_ps[pb][nb] - paths_ps[pa][na], paths_ps[pa][na] + paths_ps[pb].back() - paths_ps[pb][nb] + mn) << " ";
		}
		else {
			int pa = path[a];
			int pb = path[b];
			int na = vnum[a];
			int nb = vnum[b];
			long long p2 = min(paths_ps[pa][na] + paths_ps[pb][nb], paths_ps[pa].back() - paths_ps[pa][na] + paths_ps[pb].back() - paths_ps[pb][nb]);
			long long p3 = min(paths_ps[pa][na] + paths_ps[pb].back() - paths_ps[pb][nb] + mn, paths_ps[pb][nb] + paths_ps[pa].back() - paths_ps[pa][na] + mn);
			cout << min(p2, p3) << " ";
		}
	}
	return 0;
}