#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

struct User {
    unsigned long long rating;
};

struct School {
    string name;
    vector<User> users;
    unsigned long long rating;
};

bool operator< (const School &l, const School &r) {
    if(l.users.size() < 3) {
        return false;
    } else if(r.users.size() < 3) {
        return true;
    } else {
        return l.rating > r.rating;
    }
}

int main()
{
    map<string, School> schools;
    string uname, sname;
    unsigned long long rating;
    int n;
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> uname >> rating >> sname;
        if(schools.count(sname) == 0) {
            schools[sname] = School {
                sname,
                vector<User>(1, User{ rating }),
                rating
            };
        } else {
            schools[sname].rating += rating;
            schools[sname].users.push_back(User{rating});
        }
    }
    vector<School> result;
    for(auto iter = schools.begin(); iter != schools.end(); iter++) {
        School school = (*iter).second;
        if(school.users.size() >= 3) {
            result.push_back(school);
        }
    }
    sort(result.begin(), result.end());
    for(int i = 0; i < result.size(); i++) {
        auto school = result[i];
        cout << school.name << endl;
    }
    return 0;
}
